audio/via-ac97: Simplify code and set user_creatable to false
[qemu/ar7.git] / Makefile
blob76dbb917f5cd3085ad93cb634c14ba88b380ab53
1 # Makefile for QEMU.
3 ifneq ($(words $(subst :, ,$(CURDIR))), 1)
4 $(error main directory cannot contain spaces nor colons)
5 endif
7 # Always point to the root of the build tree (needs GNU make).
8 BUILD_DIR=$(CURDIR)
10 # Before including a proper config-host.mak, assume we are in the source tree
11 SRC_PATH=.
13 # Don't use implicit rules or variables
14 # we have explicit rules for everything
15 MAKEFLAGS += -rR
17 SHELL = /usr/bin/env bash -o pipefail
19 # Usage: $(call quiet-command,command and args,"NAME","args to print")
20 # This will run "command and args", and either:
21 # if V=1 just print the whole command and args
22 # otherwise print the 'quiet' output in the format " NAME args to print"
23 # NAME should be a short name of the command, 7 letters or fewer.
24 # If called with only a single argument, will print nothing in quiet mode.
25 quiet-command-run = $(if $(V),,$(if $2,printf " %-7s %s\n" $2 $3 && ))$1
26 quiet-@ = $(if $(V),,@)
27 quiet-command = $(quiet-@)$(call quiet-command-run,$1,$2,$3)
29 UNCHECKED_GOALS := %clean TAGS cscope ctags dist \
30 help check-help print-% \
31 docker docker-% vm-help vm-test vm-build-%
33 all:
34 .PHONY: all clean distclean recurse-all dist msi FORCE
36 # Don't try to regenerate Makefile or configure
37 # We don't generate any of them
38 Makefile: ;
39 configure: ;
41 # All following code might depend on configuration variables
42 ifneq ($(wildcard config-host.mak),)
43 include config-host.mak
45 git-submodule-update:
46 .git-submodule-status: git-submodule-update config-host.mak
47 Makefile: .git-submodule-status
49 .PHONY: git-submodule-update
51 git_module_status := $(shell \
52 cd '$(SRC_PATH)' && \
53 GIT="$(GIT)" ./scripts/git-submodule.sh status $(GIT_SUBMODULES); \
54 echo $$?; \
57 ifeq (1,$(git_module_status))
58 ifeq (no,$(GIT_UPDATE))
59 git-submodule-update:
60 $(call quiet-command, \
61 echo && \
62 echo "GIT submodule checkout is out of date. Please run" && \
63 echo " scripts/git-submodule.sh update $(GIT_SUBMODULES)" && \
64 echo "from the source directory checkout $(SRC_PATH)" && \
65 echo && \
66 exit 1)
67 else
68 git-submodule-update:
69 $(call quiet-command, \
70 (cd $(SRC_PATH) && GIT="$(GIT)" ./scripts/git-submodule.sh update $(GIT_SUBMODULES)), \
71 "GIT","$(GIT_SUBMODULES)")
72 endif
73 endif
75 # 0. ensure the build tree is okay
77 # Check that we're not trying to do an out-of-tree build from
78 # a tree that's been used for an in-tree build.
79 ifneq ($(realpath $(SRC_PATH)),$(realpath .))
80 ifneq ($(wildcard $(SRC_PATH)/config-host.mak),)
81 $(error This is an out of tree build but your source tree ($(SRC_PATH)) \
82 seems to have been used for an in-tree build. You can fix this by running \
83 "$(MAKE) distclean && rm -rf *-linux-user *-softmmu" in your source tree)
84 endif
85 endif
87 # force a rerun of configure if config-host.mak is too old or corrupted
88 ifeq ($(MESON),)
89 .PHONY: config-host.mak
90 x := $(shell rm -rf meson-private meson-info meson-logs)
91 endif
92 ifeq ($(NINJA),)
93 .PHONY: config-host.mak
94 x := $(shell rm -rf meson-private meson-info meson-logs)
95 else
96 export NINJA
97 endif
98 ifeq ($(wildcard build.ninja),)
99 .PHONY: config-host.mak
100 x := $(shell rm -rf meson-private meson-info meson-logs)
101 endif
102 ifeq ($(origin prefix),file)
103 .PHONY: config-host.mak
104 x := $(shell rm -rf meson-private meson-info meson-logs)
105 endif
107 # 1. ensure config-host.mak is up-to-date
108 config-host.mak: $(SRC_PATH)/configure $(SRC_PATH)/pc-bios $(SRC_PATH)/VERSION
109 @echo config-host.mak is out-of-date, running configure
110 @if test -f meson-private/coredata.dat; then \
111 ./config.status --skip-meson; \
112 else \
113 ./config.status && touch build.ninja.stamp; \
116 # 2. meson.stamp exists if meson has run at least once (so ninja reconfigure
117 # works), but otherwise never needs to be updated
118 meson-private/coredata.dat: meson.stamp
119 meson.stamp: config-host.mak
120 @touch meson.stamp
122 # 3. ensure generated build files are up-to-date
124 ifneq ($(NINJA),)
125 Makefile.ninja: build.ninja
126 $(quiet-@){ \
127 echo 'ninja-targets = \'; \
128 $(NINJA) -t targets all | sed 's/:.*//; $$!s/$$/ \\/'; \
129 echo 'build-files = \'; \
130 $(NINJA) -t query build.ninja | sed -n '1,/^ input:/d; /^ outputs:/q; s/$$/ \\/p'; \
131 } > $@.tmp && mv $@.tmp $@
132 -include Makefile.ninja
134 # A separate rule is needed for Makefile dependencies to avoid -n
135 build.ninja: build.ninja.stamp
136 build.ninja.stamp: meson.stamp $(build-files)
137 $(NINJA) $(if $V,-v,) build.ninja && touch $@
138 endif
140 ifneq ($(MESON),)
141 Makefile.mtest: build.ninja scripts/mtest2make.py
142 $(MESON) introspect --targets --tests --benchmarks | $(PYTHON) scripts/mtest2make.py > $@
143 -include Makefile.mtest
144 endif
146 # 4. Rules to bridge to other makefiles
148 ifneq ($(NINJA),)
149 MAKE.n = $(findstring n,$(firstword $(MAKEFLAGS)))
150 MAKE.k = $(findstring k,$(firstword $(MAKEFLAGS)))
151 MAKE.q = $(findstring q,$(firstword $(MAKEFLAGS)))
152 MAKE.nq = $(if $(word 2, $(MAKE.n) $(MAKE.q)),nq)
153 NINJAFLAGS = $(if $V,-v) $(if $(MAKE.n), -n) $(if $(MAKE.k), -k0) \
154 $(filter-out -j, $(lastword -j1 $(filter -l% -j%, $(MAKEFLAGS)))) \
156 ninja-cmd-goals = $(or $(MAKECMDGOALS), all)
157 ninja-cmd-goals += $(foreach t, $(.tests), $(.test.deps.$t))
159 makefile-targets := build.ninja ctags TAGS cscope dist clean uninstall
160 # "ninja -t targets" also lists all prerequisites. If build system
161 # files are marked as PHONY, however, Make will always try to execute
162 # "ninja build.ninja".
163 ninja-targets := $(filter-out $(build-files) $(makefile-targets), $(ninja-targets))
164 .PHONY: $(ninja-targets) run-ninja
165 $(ninja-targets): run-ninja
167 # Use "| cat" to give Ninja a more "make-y" output. Use "+" to bypass the
168 # --output-sync line.
169 run-ninja: config-host.mak
170 ifneq ($(filter $(ninja-targets), $(ninja-cmd-goals)),)
171 +$(quiet-@)$(if $(MAKE.nq),@:, $(NINJA) \
172 $(NINJAFLAGS) $(sort $(filter $(ninja-targets), $(ninja-cmd-goals))) | cat)
173 endif
174 endif
176 # Force configure to re-run if the API symbols are updated
177 ifeq ($(CONFIG_PLUGIN),y)
178 config-host.mak: $(SRC_PATH)/plugins/qemu-plugins.symbols
180 .PHONY: plugins
181 plugins:
182 $(call quiet-command,\
183 $(MAKE) $(SUBDIR_MAKEFLAGS) -C contrib/plugins V="$(V)", \
184 "BUILD", "example plugins")
185 endif # $(CONFIG_PLUGIN)
187 else # config-host.mak does not exist
188 config-host.mak:
189 ifneq ($(filter-out $(UNCHECKED_GOALS),$(MAKECMDGOALS)),$(if $(MAKECMDGOALS),,fail))
190 @echo "Please call configure before running make!"
191 @exit 1
192 endif
193 endif # config-host.mak does not exist
195 SUBDIR_MAKEFLAGS=$(if $(V),,--no-print-directory --quiet)
197 include $(SRC_PATH)/tests/Makefile.include
199 all: recurse-all
201 ROM_DIRS = $(addprefix pc-bios/, $(ROMS))
202 ROM_DIRS_RULES=$(foreach t, all clean, $(addsuffix /$(t), $(ROM_DIRS)))
203 # Only keep -O and -g cflags
204 .PHONY: $(ROM_DIRS_RULES)
205 $(ROM_DIRS_RULES):
206 $(call quiet-command,$(MAKE) $(SUBDIR_MAKEFLAGS) -C $(dir $@) V="$(V)" TARGET_DIR="$(dir $@)" $(notdir $@),)
208 .PHONY: recurse-all recurse-clean
209 recurse-all: $(addsuffix /all, $(ROM_DIRS))
210 recurse-clean: $(addsuffix /clean, $(ROM_DIRS))
212 ######################################################################
214 clean: recurse-clean
215 -$(quiet-@)test -f build.ninja && $(NINJA) $(NINJAFLAGS) -t clean || :
216 -$(quiet-@)test -f build.ninja && $(NINJA) $(NINJAFLAGS) clean-ctlist || :
217 # avoid old build problems by removing potentially incorrect old files
218 rm -f config.mak op-i386.h opc-i386.h gen-op-i386.h op-arm.h opc-arm.h gen-op-arm.h
219 find . \( -name '*.so' -o -name '*.dll' -o -name '*.[oda]' \) -type f \
220 ! -path ./roms/edk2/ArmPkg/Library/GccLto/liblto-aarch64.a \
221 ! -path ./roms/edk2/ArmPkg/Library/GccLto/liblto-arm.a \
222 -exec rm {} +
223 rm -f TAGS cscope.* *.pod *~ */*~
224 rm -f fsdev/*.pod scsi/*.pod
226 VERSION = $(shell cat $(SRC_PATH)/VERSION)
228 dist: qemu-$(VERSION).tar.bz2
230 qemu-%.tar.bz2:
231 $(SRC_PATH)/scripts/make-release "$(SRC_PATH)" "$(patsubst qemu-%.tar.bz2,%,$@)"
233 distclean: clean
234 -$(quiet-@)test -f build.ninja && $(NINJA) $(NINJAFLAGS) -t clean -g || :
235 rm -f config-host.mak config-host.h*
236 rm -f tests/tcg/config-*.mak
237 rm -f config-all-disas.mak config.status
238 rm -f tests/qemu-iotests/common.env
239 rm -f roms/seabios/config.mak roms/vgabios/config.mak
240 rm -f qemu-plugins-ld.symbols qemu-plugins-ld64.symbols
241 rm -f *-config-target.h *-config-devices.mak *-config-devices.h
242 rm -rf meson-private meson-logs meson-info compile_commands.json
243 rm -f Makefile.ninja Makefile.mtest build.ninja.stamp meson.stamp
244 rm -f config.log
245 rm -f linux-headers/asm
246 rm -Rf .sdk
248 find-src-path = find "$(SRC_PATH)/" -path "$(SRC_PATH)/meson" -prune -o \( -name "*.[chsS]" -o -name "*.[ch].inc" \)
250 .PHONY: ctags
251 ctags:
252 rm -f "$(SRC_PATH)/"tags
253 $(find-src-path) -exec ctags -f "$(SRC_PATH)/"tags --append {} +
255 .PHONY: TAGS
256 TAGS:
257 rm -f "$(SRC_PATH)/"TAGS
258 $(find-src-path) -exec etags -f "$(SRC_PATH)/"TAGS --append {} +
260 .PHONY: cscope
261 cscope:
262 rm -f "$(SRC_PATH)"/cscope.*
263 $(find-src-path) -print | sed -e 's,^\./,,' > "$(SRC_PATH)/cscope.files"
264 cscope -b -i"$(SRC_PATH)/cscope.files" -f"$(SRC_PATH)"/cscope.out
266 # Needed by "meson install"
267 export DESTDIR
269 include $(SRC_PATH)/tests/docker/Makefile.include
270 include $(SRC_PATH)/tests/vm/Makefile.include
272 print-help-run = printf " %-30s - %s\\n" "$1" "$2"
273 print-help = @$(call print-help-run,$1,$2)
275 .PHONY: help
276 help:
277 @echo 'Generic targets:'
278 $(call print-help,all,Build all)
279 $(call print-help,dir/file.o,Build specified target only)
280 $(call print-help,install,Install QEMU, documentation and tools)
281 $(call print-help,ctags/TAGS,Generate tags file for editors)
282 $(call print-help,cscope,Generate cscope index)
283 $(call print-help,sparse,Run sparse on the QEMU source)
284 @echo ''
285 ifeq ($(CONFIG_PLUGIN),y)
286 @echo 'Plugin targets:'
287 $(call print-help,plugins,Build the example TCG plugins)
288 @echo ''
289 endif
290 @echo 'Cleaning targets:'
291 $(call print-help,clean,Remove most generated files but keep the config)
292 $(call print-help,distclean,Remove all generated files)
293 $(call print-help,dist,Build a distributable tarball)
294 @echo ''
295 @echo 'Test targets:'
296 $(call print-help,check,Run all tests (check-help for details))
297 $(call print-help,bench,Run all benchmarks)
298 $(call print-help,docker,Help about targets running tests inside containers)
299 $(call print-help,vm-help,Help about targets running tests inside VM)
300 @echo ''
301 @echo 'Documentation targets:'
302 $(call print-help,html man,Build documentation in specified format)
303 @echo ''
304 ifdef CONFIG_WIN32
305 @echo 'Windows targets:'
306 $(call print-help,installer,Build NSIS-based installer for QEMU)
307 ifdef CONFIG_QGA_MSI
308 $(call print-help,msi,Build MSI-based installer for qemu-ga)
309 endif
310 @echo ''
311 endif
312 $(call print-help,$(MAKE) [targets],(quiet build, default))
313 $(call print-help,$(MAKE) V=1 [targets],(verbose build))
315 # will delete the target of a rule if commands exit with a nonzero exit status
316 .DELETE_ON_ERROR:
318 print-%:
319 @echo '$*=$($*)'